      subroutine map_sym_cavg_ppft (map, ncol, nrow, xcen, ycen)

C     Replace original map with circularly averaged map
C     
C     May 1992  Purdue University VAX 8550, T. Baker.
C     Modified 17-dec-1997 by T. Baker (rid of em.cmm).
C     Modified 7-aug-2006 by R Sinkovits, general cleanup
C     Modified 18-aug-2006 by R Sinkovits, modify map in place

      implicit none
      
      integer*4, intent(in) :: ncol, nrow
      real*4, intent(in)    :: xcen, ycen
      real*4, intent(inout) :: map(ncol,nrow)

      integer*4 inum, ir, i, j, interp, irnum(10000)
      real*4    x, y, ysq, rint(10000)
      parameter (interp=3)

      inum = nint(interp*sqrt(float(nrow)**2+float(ncol)**2))
      if(inum > 10000) print *, 'problem in map_sym_cavg'
      
      rint  = 0.0               ! f90 array syntax
      irnum = 0                 ! f90 array syntax

c     Step through image and reduce to 1d circular average
      do j = 1,nrow
         y   = real(j)-ycen
         ysq = y*y
         do i = 1,ncol
            x         = real(i)-xcen
            ir        = nint(interp*sqrt(x*x+ysq))+1
            irnum(ir) = irnum(ir)+1
            rint(ir)  = rint(ir) + map(i,j)
         enddo
      enddo

c     Normalize the 1d array
      do i = 1,inum
         if(irnum(i) > 1) rint(i) = rint(i)/real(irnum(i))
      enddo

c     Replace map with circularly averaged image
      do j = 1,nrow
         y   = real(j)-ycen
         ysq = y*y
         do i = 1,ncol
            x         = real(i)-xcen
            ir        = nint(interp*sqrt(x*x+ysq))+1
            map(i,j) = nint(rint(ir))
         enddo
      enddo
      
      return
      end subroutine map_sym_cavg_ppft
