/* add by ji for cftfit*/
#include <stdio.h>
#include <math.h>
#include "fitutil_1d.h"
/* 
   ca1d_AVG: an array of avg value at certain fft radius
   ca1d_STD: an array of std value at certain fft radius
   ndata   : is the size of the choosen fft radius part
   poly_paras : is the initial parameters for Background , Decay, defocus, also used for return values
   poly_order : is the size of poly_paras
   poly_orderb: is the size of parameters for Background
   poly_orderd: is the size of parameters for Decay
   wavelength :
   hkl_max    : is the size of have fft size, ndata <= hkl_max
   A          : Percentage of Amplitude Contrast
   Cs         : Spherical aberration constant
   pixel_size : 
   chisq      : return value
*/
/*      call cmpt_fit(ca1d_AVG(annlow),ca1d_std(annlow), ndata,annhigh,
     +              poly_paras, poly_order, poly_orderb, poly_orderd,
     +              wavelength, hkl_max, A, Cs, pixel_size, chisq)
*/
/* define used for fortran call method */
void cmpt_fit1d(double ca1d_avg[], double ca1d_std[], int * ndata,
		int *annlow, int * annhigh,
		double poly_paras[], int * poly_order, 
		int * poly_orderb, int * poly_orderd,
		double * wavelength, int * hkl_max, double * A, double * Cs, 
		double * pixel_size, double * chisq)
{
     cmpt_fit1d_(ca1d_avg, ca1d_std, ndata, annlow, annhigh,
		 poly_paras, poly_order, 
		 poly_orderb, 
		poly_orderd, wavelength, hkl_max, A, Cs, pixel_size, chisq);
}

/* real code part for ctf fiting */
void cmpt_fit1d_(double ca1d_avg[], double ca1d_std[], int * ndata, 
		 int *annlow, int *annhigh,
                double poly_paras[], int * poly_order, int * poly_orderb, 
		 int * poly_orderd,
                double * wavelength, int * hkl_max, double * A, double * Cs, 
                double * pixel_size, double * chisq)
{

  double *ca1d_id, **covar, **alpha;
  double big, small, chisqold1, tmp5, chisqold2, defcusold;
  double alamda, PI, ctf, ctf2, condnum; 
  double tmp6, B, D, fw, fw2, theta;
  int    *ia, i, j, k, ma, masq, nmfit;
  char *Outfile2;
  FILE *fp1;
     
        big   = 100000000.0;
        small = 0.000000001;
	PI =3.14159265358979323;
        ma = *ndata;
        ca1d_id = (double *) malloc (ma * sizeof(double ));
        for(i=0; i<ma; i++) ca1d_id[i] = i + (*annhigh) - ma + 1;
        
        ma  = *poly_order;
        ia  = (int *) malloc (ma * sizeof(int ));
        for(i=0; i<ma; i++) ia[i] = 1;

        covar = (double **) malloc (ma * sizeof(double ));
        alpha = (double **) malloc (ma * sizeof(double ));
        masq = ma * ma;
        covar[0] = (double *) malloc (masq * sizeof(double ));
        for (i=1; i<ma; i++) covar[i] = covar[i-1] + ma;
        alpha[0] = (double *) malloc (masq * sizeof(double ));
        for (i=1; i<ma; i++) alpha[i] = alpha[i-1] + ma;

/**********************************************************             
 * In this iteration session, all parameters are adjusted *
 **********************************************************/
        alamda = -1.0;
        for (;;)
        {
             mrqmin_1d (ca1d_id, ca1d_avg, ca1d_std, *ndata, poly_paras, ia, *poly_order,
                     covar, alpha, chisq, fpoly_ctf_1d, &alamda,
                     *poly_orderb, *poly_orderd, *wavelength, *hkl_max,
                     *A, *Cs, *pixel_size, &nmfit, *annlow, *annhigh);
             if(alamda>big || alamda<small) break;
        }
        alamda = 0.0;
        mrqmin_1d (ca1d_id, ca1d_avg, ca1d_std, *ndata, poly_paras, ia, 
		*poly_order,
                covar, alpha, chisq, fpoly_ctf_1d, &alamda,
                *poly_orderb, *poly_orderd, *wavelength, *hkl_max,
                *A, *Cs, *pixel_size, &nmfit, *annlow, *annhigh);
/* the condition number is the production of the norms of a matrix and its inverse matrix*/
  	condnum=condnumcal_1d(covar, alpha, nmfit);
  	printf("\nthe number of parameters for matrix covar is: %d\n", nmfit);
  	printf("The condition number for matrix covar is: %e\n", condnum);


        for (i=0; i<*poly_orderb; i++)
             printf("\na[%d]= %e",i, poly_paras[i]);
        for (i=*poly_orderb; i<*poly_orderb+*poly_orderd; i++)
             printf("\nb[%d]= %e",i, poly_paras[i]);
        printf ("\ndefocus: %e \n",  poly_paras[*poly_order-1]);
        printf ("chisq: %e \n\n",  *chisq);

/*******************************************************************************************            
 * In this iteration session, parameters for B, D and defocus value are adjusted seperated *
 *******************************************************************************************/
        chisqold1 = *chisq;
        ma = *poly_order;
        for(;;)
        {
/******************************/
/**** Refine defocus value ****/
/******************************/
          tmp5 = poly_paras[ma-1];
          chisqold2=*chisq;
          defcusold=poly_paras[ma-1];
          for (i=0; i<ma-1; i++) 
            ia[i]=0;
          ia[ma-1]=1;

          for (j=-20; j<=20;j++)
          {
              alamda = -1.0;
              poly_paras[ma-1] = tmp5+j*10.;
              for(;;)
                {
                   mrqmin_1d (ca1d_id, ca1d_avg, ca1d_std, *ndata, poly_paras, ia, *poly_order,
                           covar, alpha, chisq, fpoly_ctf_1d, &alamda,
                           *poly_orderb, *poly_orderd, *wavelength, *hkl_max,
                           *A, *Cs, *pixel_size, &nmfit, *annlow, *annhigh);
                   if(alamda>big || alamda<small) break;
                 }
                 alamda =0.0;
                 mrqmin_1d (ca1d_id, ca1d_avg, ca1d_std, *ndata, poly_paras, ia, *poly_order,
                         covar, alpha, chisq, fpoly_ctf_1d, &alamda,
                         *poly_orderb, *poly_orderd, *wavelength, *hkl_max,
                         *A, *Cs, *pixel_size,&nmfit, *annlow, *annhigh);

                 if(*chisq<=chisqold2)
                 {
                     chisqold2 = *chisq;
                     defcusold = poly_paras[ma-1];
                 }
          }
          poly_paras[ma-1]=defcusold;
/**********************************/
/**** Refine back ground curve ****/
/**********************************/
          alamda =-1.0;
          for (i=0; i<*poly_orderb; i++)
             ia[i]=1;
          for (i=*poly_orderb; i<*poly_orderb + *poly_orderd; i++)
             ia[i]=0;
          ia[ma-1]=0;
          for(;;)
          {
             mrqmin_1d (ca1d_id, ca1d_avg, ca1d_std, *ndata, poly_paras, ia, *poly_order,
                     covar, alpha, chisq, fpoly_ctf_1d, &alamda,
                     *poly_orderb, *poly_orderd, *wavelength, *hkl_max,
                     *A, *Cs, *pixel_size, &nmfit, *annlow, *annhigh);
             if(alamda>big || alamda<small) break;
          }

          alamda =0.0;
          mrqmin_1d (ca1d_id, ca1d_avg, ca1d_std, *ndata, poly_paras, ia, *poly_order,
                  covar, alpha, chisq, fpoly_ctf_1d, &alamda,
                  *poly_orderb, *poly_orderd, *wavelength, *hkl_max,
                  *A, *Cs, *pixel_size, &nmfit, *annlow, *annhigh);

/********************************************/
/**** Refine signal strength decay curve ****/
/********************************************/
          alamda =-1.0;
          for (i=0; i<*poly_orderb; i++)
             ia[i]=0;
          for (i=*poly_orderb; i<*poly_orderb + *poly_orderd; i++)
             ia[i]=1;
          ia[ma-1]=0;
          for(;;)
          {
             mrqmin_1d (ca1d_id, ca1d_avg, ca1d_std, *ndata, poly_paras, ia, *poly_order,
                     covar, alpha, chisq, fpoly_ctf_1d, &alamda,
                     *poly_orderb, *poly_orderd, *wavelength, *hkl_max,
                     *A, *Cs, *pixel_size, &nmfit, *annlow, *annhigh);
             if(alamda>big || alamda<small) break;
          }

          alamda =0.0;
          mrqmin_1d (ca1d_id, ca1d_avg, ca1d_std, *ndata, poly_paras, ia, *poly_order,
                  covar, alpha, chisq, fpoly_ctf_1d, &alamda,
                  *poly_orderb, *poly_orderd, *wavelength, *hkl_max,
                  *A, *Cs, *pixel_size, &nmfit, *annlow, *annhigh);


          if((*chisq-chisqold1)<small) break;
          chisqold1 = *chisq;
        }


        for (i=0; i<*poly_orderb; i++)
             printf("\na[%d]= %e",i, poly_paras[i]);
        for (i=*poly_orderb; i<*poly_orderb+*poly_orderd; i++)
             printf("\nb[%d]= %e",i, poly_paras[i]);
        printf ("\ndefocus: %e \n",  poly_paras[*poly_order-1]);
        printf ("chisq: %e \n\n",  *chisq);
	printf ("wavelength: %f\n",*wavelength);
	printf ("Cs: %f\n",*Cs);
	printf ("A: %f\n",*A);
   /*     Outfile2 = "1d_result.out";
       if ((fp1 = fopen (Outfile2, "w"))==NULL) {
          printf("%s: can't open.", Outfile2  );
          exit(-1);
        }
        else
        {
	  printf("hkl_max=%d\n",*hkl_max);
           tmp6 = 0.0;
           fprintf(fp1, "X,Y,B+CTF^2*D,Y-B,B,CTF*CTF,D\n");
           for (i=0; i<*ndata; i++) {
             tmp5 = 2.0*ca1d_id[i]/ *hkl_max- 1.0;

             tmp6 = poly_paras[0];
             tmp6 += poly_paras[1]*tmp5;
             tmp6 += poly_paras[2]*(3.0*tmp5*tmp5-1.0)/2.0;
             tmp6 += poly_paras[3]*(5.0*tmp5*tmp5*tmp5-3.0*tmp5)/2.0;
             tmp6 += poly_paras[4]*(5.0*tmp5*tmp5*tmp5*tmp5-30.0*tmp5*tmp5+3.0)/8.0;
             tmp6 += poly_paras[5]*(63.0*tmp5*tmp5*tmp5*tmp5*tmp5-70.0*tmp5*tmp5*tmp5+15.0*tmp5)/8.0;
             B = tmp6;

             tmp6 = poly_paras[6];
             tmp6 += poly_paras[7]*tmp5;
             tmp6 += poly_paras[8]*(3.0*tmp5*tmp5-1.0)/2.0;
             tmp6 += poly_paras[9]*(5.0*tmp5*tmp5*tmp5-3.0*tmp5)/2.0;
             tmp6 += poly_paras[10]*(5.0*tmp5*tmp5*tmp5*tmp5-30.0*tmp5*tmp5+3.0)/8.0;
             tmp6 += poly_paras[11]*(63.0*tmp5*tmp5*tmp5*tmp5*tmp5-70.0*tmp5*tmp5*tmp5+15.0*tmp5)/8.0;

	    D =tmp6;


           fw =*wavelength*ca1d_id[i]/(*hkl_max*2.0* *pixel_size );
           fw2= fw*fw;
           tmp5 = *wavelength;
           theta = PI*2.0*(*Cs*fw2*fw2/4.0-poly_paras[*poly_order-1]*fw2/2.0)/tmp5;
	   tmp5 = *A**A;
           ctf = sqrt(1.0-tmp5)*sin(theta)-*A*cos(theta);
           ctf2 = ctf*ctf;
            fprintf(fp1, "%f, %f, %f, %f, %f, %f, %f\n",  ca1d_id[i], ca1d_avg[i],
                B+ctf2*D, ca1d_avg[i]-B,B, ctf2,D);
           }
        }

        fclose (fp1);
*/
        free(ca1d_id);
        free(covar[0]);
        free(covar);
        free(alpha[0]);
        free(alpha);
        free(ia);
}

double condnumcal_1d(double **matrix, double **matrix2, int n)
/* compute a condition number of a matrix */
{  
	double norm, norminv;
  	double **matrixinv;
	double condnum, nsq;
        int i, j, k;
/* compute the condition number for matrix  */
        norm = normcal_1d (matrix, n);
/* compute the inverse of matrix*/
 	for (j=0;j<n;j++) 
    		for (k=0;k<n;k++) matrix2[j][k]=matrix[j][k];
  	invmatrix_1d(matrix, matrix2, n);
        norminv=normcal_1d (matrix2, n);
/* the condition number is the production of the norms of a matrix and its inverse matrix*/
	/*printf("norm1: %f, norm2: %f\n", norm, norminv);*/
	condnum = norm * norminv;
	return condnum;
}

double normcal_1d (double ** matrix, int n)
/* compute the norm of a matrix */
{
	double tmp1, tmp, norm;
        int i, j, k;
	norm = -1.0;
        for (j=0;j<n;j++) {
                tmp = 0.0;
                for (k=0; k<n;k++){
			tmp1 = matrix[j][k];
                	tmp += abs(tmp1);
		}
                if(tmp>norm) norm = tmp;
        }
        norm =sqrt (norm);	
        return norm;
}

#define SWAP1(a,b) {swap=(a);(a)=(b);(b)=swap;}

void covsrt_1d(double **covar, int ma, int ia[], int mfit)
/* Expand in storage the covariance matrix covar, so as to
   take into account parameters that are being held fixed. 
program: Numerical Recipe in C, p39
modified by Wei Zhang, change float into double*/

{
  int i, j, k;
  double swap;
  
  for (i=mfit;i<ma;i++)
    for (j=0;j<=i;j++) covar[i][j]=covar[j][i]=0.0;
  k=mfit;
  for (j=ma-1;j>=0;j--) {
    if (ia[j]) {
      k--;
      for (i=0;i<ma;i++) SWAP1(covar[i][k], covar[i][j])
      for (i=0;i<ma;i++) SWAP1(covar[k][i], covar[j][i])
    }
  }
}
      
  

#define DEBUG1 0

void fpoly_ctf_1d(double  x, double  a[], double  *y, double  dyda[], 
		  int na, int order_poly1,
		  int order_poly2, double  wavelength, 
		  int idim_half, double  A, double  Cs,
		  double  pixel_size,
		  int annlow,
		  int annhigh
		  )
{
	int i;
  	double  fac, ex, arg, y1;
  	double  fw, fw2, theta, defocus, PI, ctf, ctf2;
 	
 	PI=3.14159265358979323;
	defocus = a[na-1];
  	*y=0.0;
  	y1=0.0;
   	fw =wavelength*x/(idim_half*2.0* pixel_size );
	fw2= fw*fw;
	theta = PI*2.0*(Cs*fw2*fw2/4.0-defocus*fw2/2.0)/wavelength;
	ctf = sqrt(1.0-A*A)*sin(theta)-A*cos(theta);
 	ctf2 = ctf*ctf;
	/* OLDWAY  	arg =1.5*x/idim_half - 1.0; */
	arg =2.0*(x-annlow)/(annhigh-annlow) - 1.0;
  	*y = a[0]; 
  	dyda[0]=1;
        dyda[1]=arg;
    	*y += a[1]*arg;
        dyda[2]=(3.0*arg*arg-1.0)/2.0;
        *y += a[2]*dyda[2];
        dyda[3]=(5.0*arg*arg*arg-3.0*arg)/2.0;
        *y += a[3]*dyda[3];
        dyda[4]=(35.0*arg*arg*arg*arg-30.0*arg*arg+3.0)/8.0;
        *y += a[4]*dyda[4];
        dyda[5]=(63.0*arg*arg*arg*arg*arg-70.0*arg*arg*arg+15.0*arg)/8.0;
        *y += a[5]*dyda[5];

   	dyda[6]=ctf2;
   	y1 = a[6]; 
   	*y+= ctf2*a[6];

        dyda[7]=arg*ctf2;
        y1 += a[7]*arg;
    	*y += a[7]*dyda[7];

        dyda[8]=ctf2*(3.0*arg*arg-1.0)/2.0;
	y1 += a[8]*dyda[8]/ctf2;
        *y += a[8]*dyda[8];

        dyda[9]=ctf2*(5.0*arg*arg*arg-3.0*arg)/2.0;
	y1 +=a[9]*dyda[9]/ctf2;
        *y += a[9]*dyda[9];

        dyda[10]=ctf2*(35.0*arg*arg*arg*arg-30.0*arg*arg+3.0)/8.0;
        y1 += a[10]*dyda[10]/ctf2;
        *y += a[10]*dyda[10];

        dyda[11]=ctf2*(63.0*arg*arg*arg*arg*arg-70.0*arg*arg*arg+15.0*arg)/8.0;
        y1 += a[11]*dyda[11]/ctf2;
        *y += a[11]*dyda[11];
        
/*    	dyda[na-1]= -2.0*ctf*y1*(ctf+2.0*A*cos(theta))*PI*fw2/wavelength;
*/
    	dyda[12]= -2.0*ctf*y1*(sqrt(1.0-A*A)*cos(theta)+A*sin(theta))*PI*fw2/wavelength;
 	
 	if(DEBUG1) {   
     	   printf("\nX is %f\n", x);
    	   printf("   ymode = %f\n", *y);
            for(i=0;i<na; i++)  
                printf("   a[%d] = %f\n",i, a[i]);
            for(i=0;i<na; i++)
                printf("   dyda[%d] = %f\n",i, dyda[i]);
          } 
}
/* The routine for Gauss-Jordan elimination with full pivoting */

#define SWAP(a,b) {temp=(a); (a)=(b); (b)=temp;}

void nrerror_1d (char error_text[])
/* Numerical Recipes standard error handler */
{
  fprintf(stderr, "Numerical Recipes run-time error...\n");
  fprintf(stderr, "%s\n",error_text);
  fprintf(stderr, "...now exiting to system...\n");
  exit(1);
  }


void gaussj_1d(double **a, int n, double **b, int m)
/* Linear equation solution by Gauss-Jordan elimination, a[1..n][1..n]
is the input matrix. b[1..n][1..m] is input containing the m right-hand
side vectors. On output, a is replaced by its matrix inverse, and b is 
replaced by the corresponding set of solution vectors. 
program: Numerical Recipe in C, p39
modified by Wei Zhang, change float into double*/
{
  int *indxc, *indxr, *ipiv;
  int i, icol, irow, j, k, l, ll;
  double big, dum, pivinv, temp;
  
  indxc=(int *) malloc (n * sizeof(int));
  indxr=(int *) malloc (n * sizeof(int));
  ipiv =(int *) malloc (n * sizeof(int));
  for (j=0;j<n;j++) ipiv[j]=0;
  for (i=0;i<n;i++) {
    big=0.0;
    for (j=0;j<n;j++)
      if (ipiv[j] != 1) 
        for (k=0;k<n;k++) {
          if (ipiv[k]==0) {
            if (fabs(a[j][k]) >=big) {
              big=fabs(a[j][k]);
              irow=j;
              icol=k;
            }
          } else if (ipiv[k]>1) nrerror_1d("gaussj_1d: Singular Matrix-1");
        }
    ++(ipiv[icol]);
  
    if (irow != icol) {
      for (l=0;l<n;l++) SWAP(a[irow][l], a[icol][l])
      for (l=0;l<m;l++) SWAP(b[irow][l], b[icol][l])
    }
    indxr[i]=irow;
    indxc[i]=icol;
    if (a[icol][icol] == 0.0) nrerror_1d("gaussj_1d: Singular Matrix-2");
    pivinv=1.0/a[icol][icol];
    a[icol][icol]=1.0;
    for (l=0;l<n;l++) a[icol][l] *= pivinv;
    for (l=0;l<m;l++) b[icol][l] *= pivinv;
    for (ll=0;ll<n;ll++)
      if (ll != icol) {
        dum=a[ll][icol];
        a[ll][icol]=0.0;
        for (l=0;l<n;l++) a[ll][l] -= a[icol][l]*dum;
        for (l=0;l<m;l++) b[ll][l] -= b[icol][l]*dum;
      }
  }
    
  for (l=n-1;l>=0;l--) {
    if (indxr[l] != indxc[l])
      for (k=0;k<n;k++)
        SWAP(a[k][indxr[l]], a[k][indxc[l]]);
  }
    
  free(ipiv);
  free(indxr);
  free(indxc);
}

/* Numerical recipes in C Page 48
   Modified by Wei Zhang, May 24, 2005*/

void invmatrix_1d(double **a, double **y, int n)
{	double d,*col;
	int i,j,*indx;
	indx=(int *) malloc (n * sizeof(int));
        col =(double *) malloc (n*sizeof(double));
	ludcmp_1d(a,n,indx,&d); /*Decompose the matrix just once.*/
	for(j=0;j<n;j++) { /*Find inverse by columns.*/
		for(i=0;i<n;i++) col[i]=0.0;
		col[j]=1.0;
		lubksb_1d(a,n,indx,col);
		for(i=0;i<n;i++) y[i][j]=col[i];
	}
       free(indx);
       free(col);
}

void lubksb_1d(double **a, int n, int *indx, double b[])
/*Solves the set of n linear equations A·X = B. Here a[1..n][1..n] is input, not as the matrix
A but rather as its LU decomposition, determined by the routine ludcmp. indx[1..n] is input
as the permutation vector returned by ludcmp. b[1..n] is input as the right-hand side vector
B, and returns with the solution vector X. a, n, and indx are not modified by this routine
and can be left in place for successive calls with different right-hand sides b. This routine takes
into account the possibility that b will begin with many zero elements, so it is efficient for use
in matrix inversion.
Numerical Recipes in C. P47 
modified by Wei Zhang, May-24-2005, use double and change index from (1,2,...n) to (0,1,...,n-1)*/
{
	int i,ii=-1,ip,j;
	double sum;
	for (i=0;i<n;i++) { /*When ii is set to a positive value, it will become the
index of the first nonvanishing element of b. We now do the forward substitution, equation (2.3.6). The
only new wrinkle is to unscramble the permutation as we go.*/
		ip=indx[i];
		sum=b[ip];
		b[ip]=b[i];
		if (ii>=0)
			for (j=ii;j<=i-1;j++) sum -= a[i][j]*b[j];
		else if (sum) ii=i; /*A nonzero element was encountered, so from now on we
will have to do the sums in the loop above*/
       		b[i]=sum; 
	}
	for (i=n-1;i>=0;i--) { /*Now we do the backsubstitution, equation (2.3.7).*/
		sum=b[i];
		for (j=i+1;j<n;j++) sum -= a[i][j]*b[j];
		b[i]=sum/a[i][i]; /*Store a component of the solution vector X.*/
	} /*All done!*/
}

#define TINY 1.0e-20 /*A small number.*/
void ludcmp_1d(double **a, int n, int *indx, double *d)
/*Given a matrix a[1..n][1..n], this routine replaces it by the LU decomposition of a rowwise
permutation of itself. a and n are input. a is output, arranged as in equation (2.3.14) above;
indx[1..n] is an output vector that records the row permutation effected by the partial
pivoting; d is output as ±1 depending on whether the number of row interchanges was even
or odd, respectively. This routine is used in combination with lubksb to solve linear equations
or invert a matrix. 
Numerical recipes in C, P 46-47
     modified by Wei Zhang, change memory allocation and change float into double*/
{
	int i,imax,j,k;
	double big,dum,sum,temp;
	double *vv; /*vv stores the implicit scaling of each row.*/
	vv=(double *) malloc (n * sizeof(double));
	*d=1.0;    /*No row interchanges yet.*/
 	for (i=0;i<n;i++) { /*Loop over rows to get the implicit scaling information.*/
            	big= 0.0; 
		for (j=0;j<n;j++)
		if ((temp=fabs(a[i][j])) > big) big=temp;
		if (big == 0.0) nrerror_1d("Singular matrix in routine ludcmp");
			/*No nonzero largest element.*/
		vv[i]=1.0/big; /*Save the scaling.*/
	}
	for (j=0;j<n;j++) { /*This is the loop over columns of Crout's method.*/
		for (i=0;i<j;i++) { /*This is equation (2.3.12) except for i = j.*/
			sum=a[i][j];
			for (k=0;k<i;k++) sum -= a[i][k]*a[k][j];
		a[i][j]=sum;
		}
		big=0.0; /*Initialize for the search for largest pivot element.*/
		for (i=j;i<n;i++) { /*This is i = j of equation (2.3.12) and i = j+1. . .N
			of equation (2.3.13).*/
			sum=a[i][j]; 
			for (k=0;k<j;k++)
				sum -= a[i][k]*a[k][j];
			a[i][j]=sum;
			if ( (dum=vv[i]*fabs(sum)) >= big) {
			/*Is the figure of merit for the pivot better than the best so far?*/
			big=dum;
			imax=i;
		}
	}
	if (j != imax) { /*Do we need to interchange rows?*/
		for (k=0;k<n;k++) { /*Yes, do so...*/
			dum=a[imax][k];
			a[imax][k]=a[j][k];
			a[j][k]=dum;
		}
		*d = -(*d); /*...and change the parity of d.*/
		vv[imax]=vv[j]; /*Also interchange the scale factor.*/
	}
	indx[j]=imax;
	if (a[j][j] == 0.0) a[j][j]=TINY;
	/*If the pivot element is zero the matrix is singular (at least to the precision of the
algorithm). For some applications on singular matrices, it is desirable to substitute
TINY for zero.*/
	if (j != n) { /*Now, finally, divide by the pivot element.*/
		dum=1.0/(a[j][j]);
		for (i=j+1;i<n;i++) a[i][j] *= dum;
	}
} /*Go back for the next column in the reduction.*/
free(vv);
}


void mrqcof_1d(double x[], double y[], double sig[], int ndata, double a[], 
	       int ia[],  int ma, double **alpha, double beta[], double *chisq,
	       void (*funcs)(double, double [], double *, double [], int, 
			     int, int, double, 
			     int,  double, double, double, int , int),
	       int num_gauss_bkg, int num_gauss_ctf, double wavelength, 
	       int idim_half, double A,
	       double Cs, double pixel_size, int annlow, int annhigh)
 
  /* Used by mrqmin to evaluate the linearized fitting matrix alpha, and vector 
     beta and calculate chi square 
     
     program: Numerical Recipe in C, p686
     modified by Wei Zhang, pass more parameters and change float into double*/ 
{
  int i, j, k, l, m, mfit;
  double ymod, wt, sig2i, dy, *dyda;
  
  dyda=(double *) malloc (ma * sizeof(double));
  mfit = 0;
  for (j=0;j<ma;j++)
      if(ia[j]) mfit++;
  for(j=0;j<mfit;j++) {
      for (k=0;k<=j;k++) alpha[j][k]=0.0;
      beta[j]=0.0;
  }
  *chisq=0.0;
  for (i=0;i<ndata; i++) { 
    (*funcs)(x[i],a,&ymod,dyda,ma, num_gauss_bkg, num_gauss_ctf, wavelength, idim_half,
      A, Cs, pixel_size, annlow, annhigh);    
    sig2i=1.0/(sig[i]*sig[i]);    
    dy=y[i]-ymod;
    for (j=-1,l=0;l<ma;l++) {
       if (ia[l]) {
         wt=dyda[l]*sig2i;
         for (j++,k=0,m=0;m<=l;m++)
           if(ia[m]) alpha[j][k++]+=wt*dyda[m];
         beta[j] += dy*wt;
       }
     }
     *chisq +=dy*dy*sig2i;
  }
  for (j=1;j<mfit;j++)
     for (k=0;k<j; k++) alpha[k][j]=alpha[j][k];
  free(dyda);
}

void mrqmin_1d(double x[], double y[], double sig[], int ndata, double a[], int ia[],
	int ma, double **covar, double **alpha, double *chisq,
	void (*funcs)(double, double [], double *, double [], int, int, int, double,
	int, double, double, double, int, int ), 
	double *alamda, int num_gauss_bkg, int num_gauss_ctf, double wavelength,
	int idim_half, double A, double Cs, double pixel_size, int *nmfit,
	       int annlow, int annhigh)
/*program: Numerical Recipe in C, p687
  modified by Wei Zhang, pass more paramerters and change float into double*/
{
  int j, k, l;
  static int mfit;
  static double ochisq, *atry, *beta, *da, **oneda;

  if (*alamda < 0.0) {
    atry=(double *) malloc (ma * sizeof(double ));
    beta=(double *) malloc (ma * sizeof(double ));
    da  =(double *) malloc (ma * sizeof(double ));

    for (mfit=0,j=0;j<ma;j++)
      if (ia[j]) mfit++;
    *nmfit = mfit;
    oneda=(double **) malloc ( mfit * sizeof(double ));
    oneda[0] = (double *) malloc (mfit* sizeof(double ));
    for (j=1; j<mfit; j++) oneda[j] = oneda[j-1] + 1 ;
    *alamda=0.001;      
    mrqcof_1d(x,y,sig,ndata,a,ia,ma,alpha,beta,chisq,funcs,num_gauss_bkg,
	      num_gauss_ctf,
           wavelength, idim_half, A, Cs, pixel_size,annlow, annhigh);
    ochisq=(*chisq);
    for(j=0;j<ma;j++) atry[j]=a[j];
  }

  for (j=0;j<mfit;j++) {
    for (k=0;k<mfit;k++) covar[j][k]=alpha[j][k];
    covar[j][j]=alpha[j][j]*(1.0+(*alamda));
    oneda[j][0]=beta[j];
  }

/* call gauss solution*/
  gaussj_1d(covar, mfit, oneda, 1);

  for (j=0;j<mfit;j++) da[j]=oneda[j][0];
  if (*alamda == 0.0) {
    covsrt_1d(covar, ma, ia, mfit);
    free(oneda[0]);
    free(oneda);
    free(da);
    free(atry);
    return;
  }
  for (j=0, l=0; l<ma; l++)
    if(ia[l]) atry[l]=a[l]+da[j++];

  mrqcof_1d(x,y,sig,ndata,atry,ia,ma,covar,da,chisq,funcs,num_gauss_bkg,num_gauss_ctf,
         wavelength, idim_half, A, Cs, pixel_size, annlow, annhigh);
  if(*chisq<ochisq) {
    *alamda *= 0.1;
    ochisq=(*chisq);
    for (j=0;j<mfit; j++) {
      for (k=0;k<mfit;k++) alpha[j][k]=covar[j][k];
      beta[j]=da[j];
    }
    for(l=0;l<ma;l++) a[l]=atry[l];
  } else {
    *alamda *= 10.0;
    *chisq=ochisq;
  }
 
}
